image: node:16.14.0

services:
  - docker:dind

stages:          # List of stages for jobs, and their order of execution
  - build
  - deploy


build-job:       # This job runs in the build stage, which runs first.
  stage: build
  script:
    - node --version
    - echo "======= Installing dependencies                 =========="
    - npm i
    - echo "======= Creating oci-exports.yaml               =========="
    - echo $OCI_EXPORTS_FILE > src/oci-exports.js
    - echo "======= Building project                        =========="
    - npm run build
  artifacts:
    name: $CI_PROJECT_NAME-$CI_COMMIT_BRANCH-$CI_COMMIT_SHORT_SHA
    paths:
      - build
    expire_in: 1 week

deploy-job:      # This job runs in the deploy stage.
  image:
    name: jpoon/oci-cli:latest
    entrypoint: [""]
  stage: deploy  # It only runs when *both* jobs in the test stage complete successfully.
  script:
    - echo "======= Replacing Static URLs                   =========="
    - jsscript=`find build -name "main.*.chunk.js"`
    - sed -i  "s/\"\/img\/resume_picture/\"\/n\/$OCI_NAMESPACE\/b\/$OCI_OS_BUCKET\/o\/img\/resume_picture/g" $jsscript
    - sed -i  "s/\"\/favicon\.ico\"/\"\/n\/$OCI_NAMESPACE\/b\/$OCI_OS_BUCKET\/o\/favicon\.ico\"/g" build/index.html
    - sed -i  "s/\"\/manifest\.json\"/\"\/n\/$OCI_NAMESPACE\/b\/$OCI_OS_BUCKET\/o\/manifest\.json\"/g" build/index.html
    - sed -i  "s/\"\/img\.png\"/\"\/n\/$OCI_NAMESPACE\/b\/$OCI_OS_BUCKET\/o\/img\.png\"/g" build/index.html
    - sed -i  "s/\"\/static\/js\//\"\/n\/$OCI_NAMESPACE\/b\/$OCI_OS_BUCKET\/o\/static\/js\//g" build/index.html
    - sed -i  "s/\"\/static\/css\//\"\/n\/$OCI_NAMESPACE\/b\/$OCI_OS_BUCKET\/o\/static\/css\//g" build/index.html
    - sed -i  "s/\"static\/js\/\"/\"n\/$OCI_NAMESPACE\/b\/$OCI_OS_BUCKET\/o\/static\/js\/\"/g" build/index.html
    - cd build
    - echo "======= Deploying the project                   =========="
    - mkdir .oci
    - echo -e $OCI_CONFIG_FILE > .oci/config
    - chmod 600  .oci/config
    - echo -e $OCI_API_KEY > .oci/oci_api_key_solarpace.pem
    - chmod 600  .oci/oci_api_key_solarpace.pem
    - echo "--->Deleting existing files in $oci_os_bucket"
    - oci os object bulk-delete -ns $OCI_NAMESPACE  -bn $OCI_OS_BUCKET  --prefix static --force --config-file .oci/config
    - echo "--->Uploading new files in $OCI_OS_BUCKET"
    - oci os object put -bn $OCI_OS_BUCKET --file ./manifest.json --content-type application/json --force --config-file .oci/config
    - oci os object bulk-upload -bn $OCI_OS_BUCKET --src-dir ./ --content-type text/html --include "*.html" --overwrite --config-file .oci/config
    - oci os object bulk-upload -bn $OCI_OS_BUCKET --src-dir ./ --content-type image/jpeg --include "*.png" --overwrite --config-file .oci/config
    - oci os object bulk-upload -bn $OCI_OS_BUCKET --src-dir ./ --content-type text/javascript --include "*.js" --overwrite --config-file .oci/config
    - oci os object bulk-upload -bn $OCI_OS_BUCKET --src-dir ./ --content-type application/pdf --include '*.pdf"' --overwrite --config-file .oci/config
    - oci os object bulk-upload -bn $OCI_OS_BUCKET --src-dir ./ --content-type text/css --include "*.css" --overwrite --config-file .oci/config
    - oci os object bulk-upload -bn $OCI_OS_BUCKET --src-dir ./ --content-type text/plain --exclude "*.js" --exclude "*.html" --exclude "*.png" --exclude '*.pdf' --exclude "*.css" --exclude ./manifest.json --overwrite  --config-file .oci/config
    - echo "======= Application successfully deployed.     =========="
